<template>
  <el-main>
    <el-row type="flex" justify="end">
      <el-col>
        <el-dropdown>
          <el-button type="primary">Add panel <i class="el-icon-arrow-down el-icon--right"></i></el-button>
          <el-dropdown-menu slot="dropdown">
            <el-dropdown-item v-for="panel in this.$data.panels" :key="panel.id">
              <div @click="createUserPanel({ panelId: panel.id })">{{panel.name}}</div>
            </el-dropdown-item>
          </el-dropdown-menu>
        </el-dropdown>
        <a :href="`/calls/${this.$route.params.id}/download`" target="_blank" class="el-button el-button--primary">Download as PDF</a>
        <router-link :to="`/calls/${this.$route.params.id}/share`" class="el-button el-button--primary">Send by email</router-link>
        <router-link :to="`/calls/${this.$route.params.id}/edit`" class="el-button el-button--primary">Edit</router-link>
      </el-col>
    </el-row>
    <el-row>
      <el-col :md="12" style="padding: 10px">
        <el-card>
          <div>Filename: {{this.$data.call.fileName}}</div>
          <div>Status: {{this.$data.call.fileStatus}}</div>
          <div v-if="this.$data.call.agent">Agent: {{this.$data.call.agent.profile.fullName}}</div>
          <div v-if="this.$data.call.onlineFlag">Online flag: {{this.$data.call.onlineFlag}}</div>
          <div v-if="this.$data.call.madeAt">Made at: {{this.$data.call.madeAt}}</div>
          <div v-if="this.$data.call.duration">Duration: {{this.$data.call.duration}} seconds</div>
        </el-card>
      </el-col>
      <el-col :md="12" style="padding: 10px">
        <el-card>
          <canvas ref="radar" width="500" height="300"></canvas>
          <audio ref="audio" :src="this.$data.call.file" controls="true" style="width: 100%">
            Your browser does not support the <code>audio</code> element.
          </audio>
        </el-card>
      </el-col>
    </el-row>
    
    <user-panels :data="this.$data.user_panels" :query="this.$apollo.queries.user_panels"></user-panels>

    <router-view></router-view>
  </el-main>
</template>

<script>
import Chart from 'chart.js'
import gql from 'graphql-tag'
import CallQuery from '../../graphql/queries/call'
import UserPanelsComponent from '../../components/user_panels'

export default {
  components: {
    'user-panels': UserPanelsComponent
  },

  apollo: {
    call: {
      query: CallQuery,
      variables() { return { id: this.$route.params.id } },
      update({ call }) {
        if(call.fileStatus == 'done') {
          let canvas = $(this.$refs.radar).get(0).getContext('2d')
                      
          let current_segment = [ call.segments[0].angry, call.segments[0].upset, call.segments[0].stress,
                                  call.segments[0].concentration, call.segments[0].content,
                                  call.segments[0].intensive_thinking, call.segments[0].energy ]

          let data = { datasets: [ { data: current_segment } ],
                        labels: ['Angry', 'Upset', 'Stress', 'Concentration', 'Content', 'I. thinking', 'Energy'] }

          let settings = { type: 'radar', data: data,
                            options: { legend: { display: false }, scale: { ticks: { display: false },pointLabels: { fontSize: 13 } } } }

          let radar = new Chart(canvas, settings)

          this.$refs.audio.addEventListener('timeupdate', () => {
            for(var i in call.segments) {
              if(call.segments[i].start <= this.$refs.audio.currentTime && call.segments[i].end >= this.$refs.audio.currentTime){
                let current_segment = [ call.segments[i].angry, call.segments[i].upset, call.segments[i].stress,
                                        call.segments[i].concentrationLevel, call.segments[i].content,
                                        call.segments[i].intensiveThinking, call.segments[i].energy ]

                radar.data.datasets[0].data = current_segment
                radar.update()
              }
            }
          })
        }
        return call
      }
    },
    user_panels: {
      query: gql`{ currentUser { panels(sort: "position DESC") { id position panel(location: "calls") { id name } } } }`,
      update({ currentUser: { panels }}) { return panels }
    },
    panels: {
      query: gql`{ panels(location: "calls"){ id name } }`
    }
  },

  data() {
    return { update: false, call: { id: '', createdAt: '', madeAt: '', file: '', fileName: '', fileStatus: '',
                     onlineFlag: '', duration: '', segments: [], agent: { username: '', profile: { fullName: '' } } },
             panels: [], user_panels: [] }
  },

  mounted () {
    this.$apollo.queries.call.refetch()
  },

  watch: {
    '$route.path'(current) {
      if(current == `/calls/${this.$route.params.id}`) this.$apollo.queries.call.refetch()
    }
  },

  methods: {
    createUserPanel(userPanel) {
      console.log(userPanel)
      this.$apollo.mutate({
        mutation: gql`mutation ($userPanel: UserPanelInput!) {
          createUserPanel(userPanel: $userPanel) {
            success
            message
            errors { field message }
          }
        }`,
        variables: { userPanel: userPanel },
        update: (store, { data: { createUserPanel }}) => {
          if(createUserPanel.success) {
            this.$message.success('Panel added successfully')
            this.$apollo.queries.user_panels.refetch()
          }
          else 
            this.$message.error('Failed to add panel')
        }
      })
    }
  }
}
</script>
